SystemOrganization addCategory: #'SCouchDB-Application-Core'!

!SCouchDatabase methodsFor: '*scouchdb-application-core' stamp: 'JesusMari 8/25/2012 12:30'!
arrayOfMultipartsFrom:content
|anArray text  first rStream |

anArray := OrderedCollection new.

first:= 	'content-type: application/json' ,String crlf,String crlf , (self utf8Encode: content asJsonString).
rStream:= ReadStream on:first from:1 to:first size.
anArray add:rStream.

(content at:'_attachments') do:[:attch|
	anArray  add:attch stream	
].

^anArray



		

! !

!SCouchDatabase methodsFor: '*scouchdb-application-core' stamp: 'JesusMariAguirre 5/16/2012 10:23'!
boundary
^ adaptor boundary! !

!SCouchDatabase methodsFor: '*scouchdb-application-core' stamp: 'JesusMariAguirre 5/14/2012 09:49'!
documentCurrentRevAt: id 

	| response result |
	(id asString beginsWith: '_') 
	ifTrue: 
	[response := adaptor head: self namePrefix , id asString]	
	ifFalse:
	[response := adaptor head: self namePrefix , id asString encodeForHTTP].

	result := response etag. 
	
	response code = HTTPOK ifTrue: [ ^ result ].
	^ adaptor couchDBError: result! !

!SCouchDatabase methodsFor: '*scouchdb-application-core' stamp: 'JesusMari 4/9/2012 14:02'!
documentRevisionsAt: id 

	| response result |
	response := adaptor get: self namePrefix , id asString ,
		'?revs=true'.

	result := adaptor readJsonFrom: response.
	response code = HTTPOK ifTrue: [ ^ result ].
	^ adaptor couchDBError: result! !

!SCouchDatabase methodsFor: '*scouchdb-application-core' stamp: 'JesusMari 4/9/2012 14:03'!
documentRevsInfoAt: id 

	| response result |
	
	response := adaptor get: self namePrefix , id asString  encodeForHTTP ,
		'?revs_info=true' .

	result := adaptor readJsonFrom: response.
	response code = HTTPOK ifTrue: [ ^ result ].
	^ adaptor couchDBError: result! !

!SCouchHTTPResponse methodsFor: '*scouchdb-application-core' stamp: 'JesusMari 4/9/2012 12:33'!
etag

	| tmp |
	tmp:= header at: 'etag' ifAbsent: [nil].
	tmp ifNil:[^tmp] ifNotNil:[^tmp withoutQuoting]! !

!JsonObject methodsFor: '*scouchdb-application-core' stamp: 'JesusMariAguirre 5/14/2012 15:41'!
addAttachmentAt: name put:anAttachment
self at:'_attachments' ifAbsent:[ self at:'_attachments' put:JsonObject new].
(self at: '_attachments') at:name put:anAttachment
! !

!JsonObject methodsFor: '*scouchdb-application-core' stamp: 'JesusMari 12/26/2012 17:42'!
id
^self at:'_id' ifAbsent:[nil] ! !

!JsonObject methodsFor: '*scouchdb-application-core' stamp: 'JesusMari 9/25/2013 10:56'!
id:anId
self at:'_id' putanId ! !

!JsonObject methodsFor: '*scouchdb-application-core' stamp: 'JesusMariAguirre 5/14/2012 15:42'!
removeAttachment:anAttachment
^(self at:'_attachments') removeKey:anAttachment ifAbsent:[nil]! !

!JsonObject methodsFor: '*scouchdb-application-core' stamp: 'JesusMari 12/26/2012 17:43'!
rev
^self at:'_rev' ifAbsent:[nil] ! !

!JsonObject methodsFor: '*scouchdb-application-core' stamp: 'JesusMari 9/25/2013 10:56'!
rev:aRev
self at:'_rev' put:aRev ! !

JsonObject subclass: #SCouchDBAttachment
	instanceVariableNames: 'name fileName stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-Application-Core'!

!SCouchDBAttachment class methodsFor: 'as yet unclassified' stamp: 'JesusMariAguirre 5/16/2012 13:22'!
fromFile:aFileName
^self fromFile:aFileName includeDoc:true ! !

!SCouchDBAttachment class methodsFor: 'as yet unclassified' stamp: 'JesusMari 9/25/2013 13:27'!
fromFile:aFileName includeDoc:aBoolean
| attch aStream|


aStream := StandardFileStream readOnlyFileNamed: aFileName.
attch:=self fromStream:aStream withName:aFileName.
attch stream:nil.
aBoolean ifFalse:[attch contentLength: aStream size].
aBoolean ifFalse:[
	attch at:'follows' put:true.
	attch removeKey:'data'].
aStream close.
^attch! !

!SCouchDBAttachment class methodsFor: 'as yet unclassified' stamp: 'JesusMari 9/4/2013 18:43'!
fromStream:aStream withName:aFileName
| attch |

attch:=self new.
attch stream:aStream.
attch contentType: (MIMEDocument guessTypeFromName: aFileName) asString.
attch fileName:aFileName.
^attch! !

!SCouchDBAttachment methodsFor: 'as yet unclassified' stamp: 'JesusMariAguirre 5/16/2012 10:50'!
at:obj
(obj='data') 
ifTrue:[^self data].
^super at:obj
! !

!SCouchDBAttachment methodsFor: 'as yet unclassified' stamp: 'JesusMariAguirre 5/13/2012 12:34'!
contentLength
^self at:'length'! !

!SCouchDBAttachment methodsFor: 'as yet unclassified' stamp: 'JesusMariAguirre 5/13/2012 12:34'!
contentLength:lenght
self at:'length' put:lenght! !

!SCouchDBAttachment methodsFor: 'as yet unclassified' stamp: 'JesusMariAguirre 5/16/2012 09:51'!
contentType
^self at:'content_type'! !

!SCouchDBAttachment methodsFor: 'as yet unclassified' stamp: 'JesusMariAguirre 5/16/2012 09:51'!
contentType:type
self at:'content_type' put:type! !

!SCouchDBAttachment methodsFor: 'as yet unclassified' stamp: 'JesusMari 9/4/2013 20:10'!
data

        ^ (Base64MimeConverter mimeEncode: self stream ) contents! !

!SCouchDBAttachment methodsFor: 'as yet unclassified' stamp: 'JesusMariAguirre 5/14/2012 11:33'!
fileName
^fileName! !

!SCouchDBAttachment methodsFor: 'as yet unclassified' stamp: 'JesusMariAguirre 5/14/2012 11:33'!
fileName:aName
fileName:=aName! !

!SCouchDBAttachment methodsFor: 'as yet unclassified' stamp: 'JesusMariAguirre 5/16/2012 10:47'!
initialize:size
super initialize:size.
self at:'data' put:nil.! !

!SCouchDBAttachment methodsFor: 'as yet unclassified' stamp: 'JesusMariAguirre 5/16/2012 11:11'!
jsonWriteOn: aStream

	| needComma |
	needComma := false.
	aStream nextPut: ${.
	self associationsDo: [ :assoc |
		needComma
			ifTrue: [ aStream nextPut: $, ]
			ifFalse: [ needComma := true ].
		assoc key jsonWriteOn: aStream.
		aStream nextPut: $:.
		(assoc key  = 'data') ifTrue:[ self data jsonWriteOn: aStream ]
							 ifFalse:[assoc value jsonWriteOn: aStream]
		 ].
	aStream nextPut: $}.! !

!SCouchDBAttachment methodsFor: 'as yet unclassified' stamp: 'JesusMariAguirre 5/14/2012 11:11'!
name
^name! !

!SCouchDBAttachment methodsFor: 'as yet unclassified' stamp: 'JesusMariAguirre 5/14/2012 11:11'!
name:aName
name:=aName! !

!SCouchDBAttachment methodsFor: 'as yet unclassified' stamp: 'JesusMari 9/4/2013 20:25'!
stream
|  a |
"stream is only setted when the instance creation is done with fromStream:withName:"
stream ifNotNil: [^stream reset].
a:=StandardFileStream readOnlyFileNamed:fileName .
a binary.
^a

! !

!SCouchDBAttachment methodsFor: 'as yet unclassified' stamp: 'JesusMari 9/4/2013 18:42'!
stream:aStream
stream:=aStream.

! !

!BlockClosure methodsFor: '*scouchdb-application-core' stamp: 'JesusMari 7/27/2012 21:27'!
sourceCode
|sc|

sc:= self decompile asString.
((sc at:1) = ${) ifTrue:[
	^ sc copyFrom:2 to: (sc size - 1)
	].
^ sc! !

SCouchDBAppWrapper subclass: #SCouchDBApp
	instanceVariableNames: 'database dbAdaptor appName runner includeDocs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-Application-Core'!

!SCouchDBApp class methodsFor: 'as yet unclassified' stamp: 'JesusMari 1/6/2013 18:55'!
fromDictionary:aDic on:aViewServer
| a |
a:=super fromDictionary:aDic.
a server:aViewServer.
^a! !

!SCouchDBApp methodsFor: 'accessing' stamp: 'JesusMari 9/14/2012 13:13'!
addEvently:evently
self at:'evently' put:evently! !

!SCouchDBApp methodsFor: 'nodes' stamp: 'JesusMari 9/7/2012 01:13'!
addFilterAt:name put:aFilter

self filters at:name put: aFilter .! !

!SCouchDBApp methodsFor: 'nodes' stamp: 'JesusMari 9/7/2012 01:14'!
addListAt:name put:aList
self lists at:name put: aList .! !

!SCouchDBApp methodsFor: 'nodes' stamp: 'JesusMari 8/21/2013 19:23'!
addMustacheTemplate:aTemplate
"imports a MustacheTemplate class template "
| e i|
i:= aTemplate instance.
self templates at:(aTemplate name asString) put:( i render).
self partials addAll:i partials.
e:=i at:'evently' ifAbsent:[nil].
e ifNotNil:[ self mergeEventlyNode:e].! !

!SCouchDBApp methodsFor: 'nodes' stamp: 'JesusMari 9/7/2012 01:14'!
addShowAt:name put:aShow

self shows at:name put: aShow.! !

!SCouchDBApp methodsFor: 'nodes' stamp: 'JesusMari 9/7/2012 01:15'!
addSignatureAt:name put:aSignature
self signatures at:name put:aSignature.! !

!SCouchDBApp methodsFor: 'nodes' stamp: 'JesusMari 9/7/2012 01:16'!
addUpdateHandlerAt:name put:anUpdater

self updates at:name put: anUpdater.! !

!SCouchDBApp methodsFor: 'nodes' stamp: 'JesusMariAguirre 5/15/2012 22:03'!
addViewAt:name put:aView

self addViewAt:name put:aView  reduce:nil! !

!SCouchDBApp methodsFor: 'nodes' stamp: 'JesusMari 9/7/2012 01:17'!
addViewAt:name put:aView reduce:aReduceFunction
|v aViewCode aReduceCode|

v:=JsonObject new.
aViewCode:= (aView isKindOf: BlockClosure) 
				ifTrue:[aView]
				ifFalse:[aView asString ].

v map:(aViewCode).

aReduceCode:= (aReduceFunction isKindOf: BlockClosure) 
				ifTrue:[aReduceFunction]
				ifFalse:[aReduceFunction asString ].
aReduceFunction ifNotNil:[v at:'reduce' put:(aReduceCode)].
self views at:name put:v.
! !

!SCouchDBApp methodsFor: 'accessing' stamp: 'JesusMari 5/28/2012 11:29'!
appName
	appName ifNil:[appName:= self class asString translateToLowercase ].
	^ appName! !

!SCouchDBApp methodsFor: 'accessing' stamp: 'JesusMari 4/24/2012 14:32'!
appName: anObject
	appName := anObject! !

!SCouchDBApp methodsFor: 'initialization' stamp: 'JesusMari 8/30/2013 10:08'!
connectTo:aHost port:aPort userName:aUserName password:aPassword

dbAdaptor:=SCouchDBAdaptor new host: aHost port: aPort userName:aUserName password:aPassword.
dbAdaptor showProgress:true.



	! !

!SCouchDBApp methodsFor: 'accessing' stamp: 'JesusMari 4/24/2012 17:42'!
database
	database ifNil:[database:=self class asString asLowercase].
	^ database! !

!SCouchDBApp methodsFor: 'accessing' stamp: 'JesusMari 4/24/2012 12:18'!
database: anObject
	database := anObject! !

!SCouchDBApp methodsFor: 'accessing' stamp: 'JesusMari 9/7/2012 00:06'!
evently
^ self at:'evently' ifAbsent:[self at:'evently' put:(SCEvently new)]! !

!SCouchDBApp methodsFor: 'accessing' stamp: 'JesusMari 7/20/2012 18:17'!
filters
^ self at:'filters' ifAbsent:[self at:'filters' put:(JsonObject new)]! !

!SCouchDBApp methodsFor: 'import' stamp: 'JesusMari 7/31/2012 01:50'!
importAllAttachmentsFrom:aFolderPath
self importAllAttachmentsFrom:aFolderPath relPath:'' prefix:''
! !

!SCouchDBApp methodsFor: 'private' stamp: 'JesusMari 7/31/2012 02:09'!
importAllAttachmentsFrom:aFolderPath relPath:relPath prefix: aPrefix
| dir a elements attchPath |

dir:= FileDirectory on: (aFolderPath , relPath).
elements :=dir entries.
elements do:[:entry|
	(entry isDirectory) 
	ifTrue:[
		(relPath='') 
			ifTrue:[	self importAllAttachmentsFrom:aFolderPath relPath:(entry name) prefix:aPrefix]
			ifFalse:[	self importAllAttachmentsFrom:aFolderPath relPath:(relPath , FileDirectory pathNameDelimiter asString, entry name) prefix:aPrefix]
	]
	ifFalse:[
		
	
		a :=SCouchDBAttachment fromFile: (aFolderPath,relPath , FileDirectory pathNameDelimiter asString, entry name) includeDoc:self includeDocs. 

		(relPath='') 
			ifFalse:[attchPath:=(relPath , FileDirectory pathNameDelimiter asString, entry name)]
			ifTrue:[attchPath:=( entry name)].
		attchPath:= attchPath copyReplaceAll: '\' with: '/'.
		a name:  attchPath.
		self addAttachmentAt: (aPrefix,attchPath) put: a  

	]
]
! !

!SCouchDBApp methodsFor: 'import' stamp: 'JesusMari 7/31/2012 02:14'!
importAllEventlyFilesFrom:aFolderPath 
self importVendorFilesFrom:aFolderPath relPath:'' stack: self evently! !

!SCouchDBApp methodsFor: 'import' stamp: 'JesusMari 10/4/2012 18:23'!
importAllTemplatesFrom:aFolderPath 
|i|
i:=Mustache instanceFromFolder:aFolderPath.
self at:'templates' put:i! !

!SCouchDBApp methodsFor: 'private' stamp: 'JesusMari 7/12/2012 10:54'!
importAllTemplatesFrom:aFolderPath relPath:relPath
| dir a elements attchPath fileName aStream |

dir:= FileDirectory on: (aFolderPath , relPath).
elements :=dir entries.
elements do:[:entry|
	(entry isDirectory) 
	ifTrue:[
		(relPath='') 
			ifTrue:[	self importAllTemplatesFrom:aFolderPath relPath:(entry name)]
			ifFalse:[	self importAllTemplatesFrom:aFolderPath relPath:(relPath , FileDirectory pathNameDelimiter asString, entry name)]
	]
	ifFalse:[
		fileName:= entry name copyFrom:1 to:((entry name indexOf:$.) - 1). 
		(relPath='') 
			ifFalse:[
				attchPath:=(relPath , FileDirectory pathNameDelimiter asString, fileName).
				attchPath:= attchPath copyReplaceAll: '\' with: '/'.
				aStream := StandardFileStream readOnlyFileNamed: entry fullName.	
				aStream ascii.
				self partials at: attchPath put: (aStream contents)
				]
			ifTrue:[
				attchPath:= fileName.
				aStream := StandardFileStream readOnlyFileNamed: entry fullName.	
				aStream ascii.
				self templates at: attchPath put: (aStream contents)
				].
	]
]! !

!SCouchDBApp methodsFor: 'import' stamp: 'JesusMari 7/31/2012 01:36'!
importVendorFilesFrom:aFolderPath 
self importVendorFilesFrom:aFolderPath relPath:'' stack: self vendor! !

!SCouchDBApp methodsFor: 'private' stamp: 'JesusMari 7/31/2012 02:09'!
importVendorFilesFrom:aFolderPath relPath:relPath stack:currentJsonObject
| dir a elements attchPath fileName aStream aTempl |

dir:= FileDirectory on: (aFolderPath , relPath).
elements :=dir entries.
elements do:[:entry|
	(entry isDirectory) 
	ifTrue:[
		((entry name) = '_attachments') 
		ifTrue:[
			self importAllAttachmentsFrom: (aFolderPath , relPath , FileDirectory pathNameDelimiter asString, entry name) relPath:'' prefix: (('vendor',relPath,'/' ) copyReplaceAll: '\' with: '/').
			]
		ifFalse:[
			currentJsonObject at: entry name put: JsonObject new.
			self importVendorFilesFrom:aFolderPath 
				relPath:(relPath , FileDirectory pathNameDelimiter asString, entry name)
				stack:(currentJsonObject at: entry name).]
	]
	ifFalse:[
		fileName:= entry name copyFrom:1 to:((entry name indexOf:$.) - 1). 
		aStream := StandardFileStream readOnlyFileNamed: entry fullName.	
		currentJsonObject at: fileName put: (
			 [Json readFrom: (SCouchUTF8Stream on: aStream)]
						on:Exception 
						do:[aStream contents]
			)
	]
]! !

!SCouchDBApp methodsFor: 'accessing' stamp: 'JesusMariAguirre 5/16/2012 13:14'!
includeDocs
^includeDocs! !

!SCouchDBApp methodsFor: 'accessing' stamp: 'JesusMariAguirre 5/16/2012 13:14'!
includeDocs:aBool
includeDocs:=aBool! !

!SCouchDBApp methodsFor: 'initialization' stamp: 'JesusMari 9/26/2013 09:48'!
initialize:size
super initialize:size.
self includeDocs:false.
self language:'smalltalk'.

self initialize
! !

!SCouchDBApp methodsFor: 'accessing' stamp: 'JesusMari 4/8/2012 15:27'!
language
	^self at:'language'! !

!SCouchDBApp methodsFor: 'accessing' stamp: 'JesusMari 4/8/2012 15:27'!
language: anObject
	self at:'language' put: anObject! !

!SCouchDBApp methodsFor: 'accessing' stamp: 'JesusMari 7/30/2012 09:08'!
lib
^ self at:'lib' ifAbsent:[self at:'lib' put:(JsonObject new)]! !

!SCouchDBApp methodsFor: 'accessing' stamp: 'JesusMari 4/8/2012 15:28'!
lib: anObject
	self at:'lib' put: anObject! !

!SCouchDBApp methodsFor: 'accessing' stamp: 'JesusMari 7/20/2012 18:05'!
lists
^ self at:'lists' ifAbsent:[self at:'lists' put:(JsonObject new)]! !

!SCouchDBApp methodsFor: 'as yet unclassified' stamp: 'JesusMari 8/21/2013 19:01'!
mergeEventlyNode:evently
self evently addAll: evently! !

!SCouchDBApp methodsFor: 'accessing' stamp: 'JesusMari 8/22/2013 10:22'!
partials
| templates |
templates:= self at:'templates' ifAbsentPut:[JsonObject new].
^ templates at:'partials' ifAbsentPut:[JsonObject new]! !

!SCouchDBApp methodsFor: 'nodes' stamp: 'JesusMari 5/9/2012 19:01'!
removeFilter:aFilter

(self at:'filters' ) removeKey:aFilter.! !

!SCouchDBApp methodsFor: 'nodes' stamp: 'JesusMari 4/9/2012 10:56'!
removeList:aList

(self at:'lists' ) removeKey:aList.! !

!SCouchDBApp methodsFor: 'nodes' stamp: 'JesusMari 4/9/2012 10:58'!
removeShow:aShow
(self at:'shows' ) removeKey:aShow! !

!SCouchDBApp methodsFor: 'nodes' stamp: 'JesusMari 4/9/2012 10:58'!
removeSignature:aSignature
(self at:'signatures' ) removeKey:aSignature! !

!SCouchDBApp methodsFor: 'nodes' stamp: 'JesusMari 5/9/2012 19:56'!
removeUpdateHandler:anUpdater

(self at:'updates' ) removeKey:anUpdater.! !

!SCouchDBApp methodsFor: 'nodes' stamp: 'JesusMari 4/9/2012 10:58'!
removeView:aView
(self at:'views' ) removeKey:aView.! !

!SCouchDBApp methodsFor: 'accessing' stamp: 'JesusMari 3/15/2013 09:32'!
runner
	^self
! !

!SCouchDBApp methodsFor: 'import' stamp: 'JesusMari 9/25/2013 14:36'!
sendAllAttachmentsFrom:aFolderPath
self sendAllAttachmentsFrom:aFolderPath relPath:'' prefix:''
! !

!SCouchDBApp methodsFor: 'private' stamp: 'JesusMari 9/25/2013 14:38'!
sendAllAttachmentsFrom:aFolderPath relPath:relPath prefix: aPrefix
| dir a elements attchPath db|

dir:= FileDirectory on: (aFolderPath , relPath).
elements :=dir entries.
elements do:[:entry|
	(entry isDirectory) 
	ifTrue:[
		(relPath='') 
			ifTrue:[	self sendAllAttachmentsFrom:aFolderPath relPath:(entry name) prefix:aPrefix]
			ifFalse:[	self sendAllAttachmentsFrom:aFolderPath relPath:(relPath , FileDirectory pathNameDelimiter asString, entry name) prefix:aPrefix]
	]
	ifFalse:[
		
	
		a :=SCouchDBAttachment fromFile: (aFolderPath,relPath , FileDirectory pathNameDelimiter asString, entry name) includeDoc:self includeDocs. 

		(relPath='') 
			ifFalse:[attchPath:=(relPath , FileDirectory pathNameDelimiter asString, entry name)]
			ifTrue:[attchPath:=( entry name)].
		attchPath:= attchPath copyReplaceAll: '\' with: '/'.
		a name:  attchPath.
		db:=dbAdaptor showProgress: false;ensureDatabase: self database.
		
		db documentAt:('_design/', self appName) attach: a.	

	]
]
! !

!SCouchDBApp methodsFor: 'private' stamp: 'JesusMari 2/3/2013 13:12'!
shows
"shows node for CouchDB show functions"
^ self at:'shows' ifAbsent:[self at:'shows' put:(JsonObject new)]! !

!SCouchDBApp methodsFor: 'accessing' stamp: 'JesusMari 8/22/2013 10:21'!
signatures
^ self at:'signatures' ifAbsentPut:[JsonObject new]! !

!SCouchDBApp methodsFor: 'accessing' stamp: 'JesusMari 8/22/2013 10:21'!
templates
"updates node for Mustache Templates"
^ self at:'templates' ifAbsentPut:[JsonObject new]! !

!SCouchDBApp methodsFor: 'accessing' stamp: 'JesusMari 8/22/2013 10:21'!
updates
"updates node for CouchDB update functions"
^ self at:'updates' ifAbsentPut: [JsonObject new].
! !

!SCouchDBApp methodsFor: 'initialization' stamp: 'JesusMari 9/25/2013 11:05'!
upload
|db attchs |
"Upload the application and put the compiled block inside the application cache"
dbAdaptor ifNil:[^nil].

(self language = 'smalltalk') ifTrue:[
	"include the app in the CouchViewServer cache (only for smalltalk language)"
	SCouchDBViewServer servers do:[:aServer| 
	(aServer designDocs at:('_design/', self appName))  ifNotNil:[
		(aServer designDocs at:('_design/', self appName)) indexers do:[:anIndexer|
			anIndexer stop.
			]
		].	
	aServer designDocs at:('_design/', self appName) put:self ]].

db:=dbAdaptor ensureDatabase: self database.
db documentAt:('_design/', self appName) update: self.	! !

!SCouchDBApp methodsFor: 'accessing' stamp: 'JesusMari 8/22/2013 10:21'!
validateDocUpdate
	^ self at:'validate_doc_update' ifAbsentPut:['[]']! !

!SCouchDBApp methodsFor: 'accessing' stamp: 'JesusMari 8/20/2012 19:42'!
validateDocUpdate: anObject
	self at:'validate_doc_update' put: anObject ! !

!SCouchDBApp methodsFor: 'accessing' stamp: 'JesusMari 8/22/2013 10:20'!
vendor
^ self at:'vendor' ifAbsentPut:[JsonObject new]! !

!SCouchDBApp methodsFor: 'accessing' stamp: 'JesusMari 8/22/2013 10:20'!
views
^ self at:'views' ifAbsentPut:[JsonObject new]! !
